{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    Courses
{% endblock %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>


{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-plus"></i>
                Create Course
            </h2>
            <ul class="nav navbar-right panel_toolbox">
                <li>

                    <button class="btn1 btn-dark-green" type="button" data-toggle="modal"
                            data-target="#myModal">
                        Add Course
                    </button>
                    <form id="submit_form" method="POST">{% csrf_token %}
                        <div class="modal" id="myModal" tabindex="-1" role="dialog"
                             aria-labelledby="myModalLabel1" aria-hidden="true">
                            <div class="modal-dialog modal-lg" role="document">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                        <h4 class="modal-title" id="myModalLabel1"><b> Add New Course </b></h4>
                                    </div>
                                    <div class="modal-body">
                                        <div class="form-horizontal form-label-left">

                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Regulation
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <select class="form-control" name="regulation" id="regulation"
                                                            required>
                                                        <option value="" disabled selected>Choose Regulation</option>
                                                        {% for regulation in list_of_regulations %}
                                                            <option value="{{ regulation.pk }}">{{ regulation }}</option>
                                                        {% endfor %}
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Course Type
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <div id="div" class="form-check">
                                                        <label class="form-check-label">
                                                            <input class="form-check-input" type="radio"
                                                                   name="coursetype" value="normal">
                                                            Normal
                                                            <input class="form-check-input" type="radio"
                                                                   name="coursetype" value="elective">
                                                            Elective
                                                            <input class="form-check-input" type="radio"
                                                                   name="coursetype"
                                                                   value="open">
                                                            Open
                                                            <input class="form-check-input" type="radio"
                                                                   name="coursetype"
                                                                   value="onecredit">
                                                            One Credit
                                                        </label>
                                                    </div>
                                                </div>
                                            </div>

                                            <div class="form-group" id="departmenttab" style="display: none">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Department
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <select class="form-control" name="department" id="department"
                                                            required>
                                                        <option value="" disabled selected>Choose Department</option>
                                                        {% for each in list_of_departments %}
                                                            <option value="{{ each.pk }}">{{ each.acronym }}</option>
                                                        {% endfor %}
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="form-group" id="programmetab" style="display: none">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Programme
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <select class="form-control" name="programme" id="programme"
                                                            required>
                                                        <option value="" disabled selected>Choose Programme</option>
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="form-group" id="semestertab" style="display: none">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Semester
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <select class="form-control" name="semester" id="semester" required>
                                                        <option value="" disabled selected>Choose Semester</option>
                                                    </select>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Course ID
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" placeholder="Course Code" type="text"
                                                           name="courseid" id="courseid" maxlength="8" required>
                                                </div>
                                            </div>

                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Course Name
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" placeholder="Name of the Course"
                                                           type="text" name="coursename" id="coursename" maxlength="150"
                                                           required>
                                                </div>
                                            </div>

                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Subject Category
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <select class="form-control" name="subjecttype" id="subjecttype"
                                                            required>
                                                        <option value="" disabled selected>Choose Category</option>
                                                        <option value="T">Theory</option>
                                                        <option value="P">Practical</option>
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    CAT
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <select class="form-control" name="cat" id="cat" required>
                                                        <option value="" disabled selected>Choose CAT</option>
                                                        {% for each in available_CAT %}
                                                            <option value="{{ each }}">{{ each }}</option>
                                                        {% endfor %}
                                                    </select>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    CAT Marks
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" id="catmarks" name="catmarks"
                                                           maxlength="3"
                                                           onkeypress="return isNumberKey(event)" required>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    End Semester Marks
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" type="text" name="endsemmarks"
                                                           id="endsemmarks" maxlength="3"
                                                           onkeypress="return isNumberKey(event)" required>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    L Credits
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" type="text" name="lcredits"
                                                           id="lcredits" maxlength="3"
                                                           onkeypress="return isNumberKey(event)" required>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    T Credits
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" type="text" name="tcredits"
                                                           id="tcredits" maxlength="3"
                                                           onkeypress="return isNumberKey(event)" required>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    P Credits
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" type="text" name="pcredits"
                                                           id="pcredits" maxlength="3"
                                                           onkeypress="return isNumberKey(event)" required>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    C Credits
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" placeholder=""
                                                           type="text" name="ccredits"
                                                           id="ccredits" maxlength="3"
                                                           onkeypress="return isNumberKey(event)" required>
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                    Course Abbreviation
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <input class="form-control" placeholder="Shorthand code for Course"
                                                           type="text" name="code" id="code" maxlength="10">
                                                </div>
                                            </div>


                                            <div class="form-group">
                                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                </label>
                                                <div class="col-md-6 col-sm-6 col-xs-12">
                                                    <button name="addcourse" type="submit" class="btn1 btn1-success">
                                                        Add Course
                                                    </button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn1 btn1-default" data-dismiss="modal">Close
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </li>
            </ul>
{#            <ul class="nav navbar-right panel_toolbox">#}
{#                <li><a class="btn1 btn1-danger" href="{% url 'delete_course_from_db' %}"#}
{#                       style="color: #000000">Delete Course</a>#}
{#                </li>#}
{#            </ul>#}
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="row">
                <select class="selectpicker" name="displayprogramme" id="displayprogramme"
                        required>
                    <option value="all">ALL Programme</option>
                    <option value="UG">UG</option>
                    <option value="PG">PG</option>
                    <option value="phd">Phd</option>
                </select>
                <select class="selectpicker" name="displayregulation" id="displayregulation"
                        required>
                    <option value="all">ALL Regulations</option>
                    {% for regulation in list_of_regulations %}
                        <option value="{{ regulation }}">{{ regulation }}</option>
                    {% endfor %}
                </select>
            </div>
            <br>
            <form>
                <div class="table-responsive">
                    <table class="table table-hover table-striped table-bordered"
                           style="">
                        <thead>
                        <tr>
                            <th>S. No.</th>
                            <th>Course ID</th>
                            <th colspan="2">Course Name</th>
                            <th>Semester</th>
                            <th>Programme</th>
                            <th>Regulation</th>
                            <th>Elective</th>
                            <th>Open</th>
                            <th>One Credit</th>
                            <th>#</th>
                        </tr>
                        </thead>
                        <tbody id="content">
                        {% for course in list_of_courses %}
                            <tr>
                                <td align="center">{{ forloop.counter }}</td>
                                <td>{{ course.course_id }}</td>
                                <td colspan="2">{{ course.course_name }}</td>
                                <td align="center">
                                    {% if course.semester == 0 %}
                                        Exceptional
                                    {% else %}
                                        {{ course.semester }}
                                    {% endif %}
                                </td>
                                <td align="center">{{ course.programme }}</td>
                                <td align="center">{{ course.regulation }}</td>
                                <td align="center">
                                    {% if course.is_elective %}
                                        <i class="glyphicon glyphicon-ok"></i>
                                    {% endif %}
                                </td>
                                <td align="center">
                                    {% if course.is_open %}
                                        <i class="glyphicon glyphicon-ok"></i>
                                    {% endif %}
                                </td>
                                <td align="center">
                                    {% if course.is_one_credit %}
                                        <i class="glyphicon glyphicon-ok"></i>
                                    {% endif %}
                                </td>
                                <td align="center"><input class="btn1-sm btn-mdb" id="editbtn" type="button"
                                                          name="{{ course.pk }}"
                                                          value="View/Edit"></td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </form>
        </div>
    </div>



    <script type="text/javascript">

        function isNumberKey(evt) {
            var charCode = (evt.which) ? evt.which : evt.keyCode;
            if (charCode != 46 && charCode > 31
                && (charCode < 48 || charCode > 57))
                return false;

            return true;
        }

        $(document).on("change", '[name="coursetype"]', function (e) {
            $('#departmenttab').show();
            $('#programmetab').show();
            $('#semestertab').show();
            $('#programme').val('');
            $('#semester').empty();
            $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
            $('#semester').val('');
        });

        $(document).on("change", '#department', function (e) {
            var department = $(this).val();
            var course_type = $("input[name=coursetype]:checked").val();
            //alert($("input[name=coursetype]:checked").val());

            $.ajax({
                type: "POST",
                data: {
                    department: department,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_course_to_db' %}',

                success: function (data) {
                    $('#programme').empty();
                    $('#programme').append('<option value="" disabled selected>Choose Programme</option>');
                    $('#programme').val('');
                    counter = 1;
                    $.each(data.list, function (key, val) {
                        $('#programme').append('<option value="' + val + '">' + val + '</option>');
                    })

                }
            });
        });

        $(document).on("change", '#programme', function (e) {
            var programme = $(this).val();
            var course_type = $("input[name=coursetype]:checked").val();
            //alert($("input[name=coursetype]:checked").val());

            if (programme == 'UG') {
                $('#semester').empty();
                $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
                $('#semester').append('<option value="1">1st Semester</option>');
                $('#semester').append('<option value="2">2nd Semester</option>');
                $('#semester').append('<option value="3">3rd Semester</option>');
                $('#semester').append('<option value="4">4th Semester</option>');
                $('#semester').append('<option value="5">5th Semester</option>');
                $('#semester').append('<option value="6">6th Semester</option>');
                $('#semester').append('<option value="7">7th Semester</option>');
                $('#semester').append('<option value="8">8th Semester</option>');
            }
            else {
                $('#semester').empty();
                $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
                $('#semester').append('<option value="1">1st Semester</option>');
                $('#semester').append('<option value="2">2nd Semester</option>');
                $('#semester').append('<option value="3">3rd Semester</option>');
                $('#semester').append('<option value="4">4th Semester</option>');
            }
        });

        $(document).on("change", '#displayprogramme', function (e) {
            var programme = $(this).val();
            var regulation = $('#displayregulation').val();
            //alert(regulation);


            $.ajax({
                type: "POST",
                data: {
                    programme: programme,
                    regulation: regulation,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_course_to_db' %}',

                success: function (data) {
                    document.getElementById('content').innerHTML = "";
                    counter = 1;
                    $.each(data.list, function (key, val) {
                        document.getElementById('content').innerHTML += '<tr><td>' + counter++ + '</td>' +
                            '<td align="center">' + val.course_id + '</td>' +
                            '<td colspan="2">' + val.course_name + '</td>' +
                            '<td align="center">' + val.semester + '</td>' +
                            '<td align="center">' + val.programme + '</td>' +
                            '<td align="center">' + val.regulation + '</td>' +
                            '<td align="center">' + val.is_elective + '</td>' +
                            '<td align="center">' + val.is_open + '</td></td>' +
                            '<td align="center">' + val.is_one_credit + '</td></td>' +
                            '<td align="center"><input class=\"btn btn-info\" id=\"editbtn\" type=\"button\" name=\"' + val.pk +
                            '"value=\"View/Edit\"></td></tr>';
                    })

                }
            });

        });

        $(document).on("change", '#displayregulation', function (e) {
            var regulation = $(this).val();
            var programme = $('#displayprogramme').val();
            //alert(regulation);


            $.ajax({
                type: "POST",
                data: {
                    programme: programme,
                    regulation: regulation,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_course_to_db' %}',

                success: function (data) {
                    document.getElementById('content').innerHTML = "";
                    counter = 1;
                    $.each(data.list, function (key, val) {
                        document.getElementById('content').innerHTML += '<tr><td>' + counter++ + '</td>' +
                            '<td align="center">' + val.course_id + '</td>' +
                            '<td colspan="2">' + val.course_name + '</td>' +
                            '<td align="center">' + val.semester + '</td>' +
                            '<td align="center">' + val.programme + '</td>' +
                            '<td align="center">' + val.regulation + '</td>' +
                            '<td align="center">' + val.is_elective + '</td>' +
                            '<td align="center">' + val.is_open + '</td></td>' +
                            '<td align="center">' + val.is_one_credit + '</td></td>' +
                            '<td align="center"><input class=\"btn btn-info\" id=\"editbtn\" type=\"button\" name=\"' + val.pk +
                            '"value=\"View/Edit\"></td></tr>';
                    })

                }
            });

        });

{#        $(document).on("focusout", '#courseid', function (e) {#}
{#            var courseid = $(this).val();#}
{#            //alert(courseid);#}
{##}
{##}
{#            $.ajax({#}
{#                type: "POST",#}
{#                data: {#}
{#                    courseid: courseid,#}
{#                    csrfmiddlewaretoken: getCookie('csrftoken'),#}
{#                },#}
{#                url: '{% url 'add_course_to_db' %}',#}
{##}
{#                success: function (data) {#}
{#                    //alert(data.list);#}
{#                    if (data.list == 'true') {#}
{#                        alert('Course ID already exists');#}
{#                        $('#courseid').val('');#}
{#                        $('#courseid').focus();#}
{#                    }#}
{#                }#}
{#            });#}
{##}
{#        });#}

        $(document).on("click", '#editbtn', function (e) {
            var courseid = $(this).attr('name');
            //alert(courseid);

            $.ajax({
                type: "POST",
                data: {
                    courseid: courseid,
                    view: 'true',
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_course_to_db' %}',

                success: function (data) {
                    window.open('{% url 'view_course_to_db' %}', '_self')
                }
            });

        });

        $(document).on("submit", '#submit_form', function (e) {
            e.preventDefault();
            var courseid = $('#courseid').val();

            var regex = new RegExp("^([A-Za-z0-9]+)$");

            if(!regex.test(courseid)){
                alert('Course ID should contains only letters and numbers!');
                return;
            }

            $('#submit_form').submit();

        });

    </script>

{% endblock %}